## libics 1.6.2

=== CMakeLists.txt ===
##############################################################################
#
# libics: Image Cytometry Standard file reading and writing.
#
# Copyright (C) 2000-2013, 2016 Cris Luengo and others
# Copyright 2015, 2016:
#   Scientific Volume Imaging Holding B.V.
#   Laapersveld 63, 1213 VB Hilversum, The Netherlands
#   https://www.svi.nl
#
#   CMakeLists.txt
#   Created by Paul Barber <paul.barber@oncology.ox.ac.uk>, Feb 2017
#   Heavily modified by Cris Luengo, July 2017
#
##############################################################################
cmake_minimum_required(VERSION 3.0)

project(libics VERSION 1.6.2)

# Note: the version number above is not yet used anywhere.
# TODO: rewrite the header file with this version number.
# The line below does not work: we need the installed header file to contain the version number also.
#add_definitions(-DICSLIB_VERSION="${libics_VERSION}")

# Compiler flags
set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED on)
# TODO: This flags works for GCC and CLang, not sure about other compilers
set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -Wall")

# Debug or Release?
if(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE Release)
endif()

# Zlib
find_package(ZLIB)
if(ZLIB_FOUND)
   set(USE_ZLIB TRUE CACHE BOOL "Use Zlib")
endif()
if(USE_ZLIB)
   include_directories(${ZLIB_INCLUDE_DIRS})
   add_definitions(-DICS_ZLIB)
endif()

# ICS
configure_file(libics_conf.h.in ${PROJECT_SOURCE_DIR}/libics_conf.h COPYONLY)
set(SOURCES
      libics_binary.c
      libics_compress.c
      libics_data.c
      libics_gzip.c
      libics_history.c
      libics_preview.c
      libics_read.c
      libics_sensor.c
      libics_test.c
      libics_top.c
      libics_util.c
      libics_write.c
      libics_conf.h
      )

set(HEADERS
      libics.h
      libics_intern.h
      libics_ll.h
      libics_sensor.h
      libics_test.h
      )

include_directories(${PROJECT_SOURCE_DIR})

# Build a dll
add_library(libics SHARED ${SOURCES} ${HEADERS})
target_compile_definitions(libics PRIVATE BUILD_ICSLIB) # For Windows, when compiling DLL
target_compile_definitions(libics INTERFACE USE_ICSLIB_DLL) # For Windows, when linking against DLL

# Build a static library
add_library(libics_static STATIC ${SOURCES} ${HEADERS})

# Link against zlib
if(USE_ZLIB)
    target_link_libraries(libics ${ZLIB_LIBRARIES})
    target_link_libraries(libics_static ${ZLIB_LIBRARIES})
endif()

# Install
install(TARGETS libics libics_static DESTINATION lib)
install(FILES ${HEADERS} DESTINATION include)

# Unit tests
enable_testing()
add_executable(test_ics1 EXCLUDE_FROM_ALL test_ics1.c)
target_link_libraries(test_ics1 libics)
add_executable(test_ics2a EXCLUDE_FROM_ALL test_ics2a.c)
target_link_libraries(test_ics2a libics)
add_executable(test_ics2b EXCLUDE_FROM_ALL test_ics2b.c)
target_link_libraries(test_ics2b libics)
add_executable(test_gzip EXCLUDE_FROM_ALL test_gzip.c)
target_link_libraries(test_gzip libics)
add_executable(test_compress EXCLUDE_FROM_ALL test_compress.c)
target_link_libraries(test_compress libics)
add_executable(test_strides EXCLUDE_FROM_ALL test_strides.c)
target_link_libraries(test_strides libics)
add_executable(test_strides2 EXCLUDE_FROM_ALL test_strides2.c)
target_link_libraries(test_strides2 libics)
add_executable(test_strides3 EXCLUDE_FROM_ALL test_strides3.c)
target_link_libraries(test_strides3 libics)
add_executable(test_metadata EXCLUDE_FROM_ALL test_metadata.c)
target_link_libraries(test_metadata libics)
add_executable(test_history EXCLUDE_FROM_ALL test_history.c)
target_link_libraries(test_history libics)
add_custom_target(all_tests DEPENDS
      test_ics1
      test_ics2a
      test_ics2b
      test_gzip
      test_compress
      test_strides
      test_strides2
      test_strides3
      test_metadata
      test_history
      )
add_test(ctest_build_test_code "${CMAKE_COMMAND}" --build ${PROJECT_BINARY_DIR} --target all_tests)
add_test(NAME test_ics1 COMMAND test_ics1 ${PROJECT_SOURCE_DIR}/test/testim.ics result_v1.ics)
set_tests_properties(test_ics1 PROPERTIES DEPENDS ctest_build_test_code)
add_test(NAME test_ics2a COMMAND test_ics2a ${PROJECT_SOURCE_DIR}/test/testim.ics result_v2a.ics)
set_tests_properties(test_ics2a PROPERTIES DEPENDS ctest_build_test_code)
add_test(NAME test_ics2b COMMAND test_ics2b ${PROJECT_SOURCE_DIR}/test/testim.ics result_v2b.ics)
set_tests_properties(test_ics2b PROPERTIES DEPENDS ctest_build_test_code)
add_test(NAME test_gzip COMMAND test_gzip ${PROJECT_SOURCE_DIR}/test/testim.ics result_v2z.ics)
set_tests_properties(test_gzip PROPERTIES DEPENDS ctest_build_test_code)
add_test(NAME test_compress COMMAND test_compress ${PROJECT_SOURCE_DIR}/test/testim.ics ${PROJECT_SOURCE_DIR}/test/testim_c.ics)
set_tests_properties(test_compress PROPERTIES DEPENDS ctest_build_test_code)
add_test(NAME test_strides COMMAND test_strides ${PROJECT_SOURCE_DIR}/test/testim.ics result_s.ics)
set_tests_properties(test_strides PROPERTIES DEPENDS ctest_build_test_code)
add_test(NAME test_strides2 COMMAND test_strides2 ${PROJECT_SOURCE_DIR}/test/testim.ics result_s2.ics)
set_tests_properties(test_strides2 PROPERTIES DEPENDS ctest_build_test_code)
add_test(NAME test_strides3 COMMAND test_strides3 ${PROJECT_SOURCE_DIR}/test/testim.ics result_s3.ics)
set_tests_properties(test_strides3 PROPERTIES DEPENDS ctest_build_test_code)
add_test(NAME test_metadata1 COMMAND test_metadata result_v1.ics)
set_tests_properties(test_metadata1 PROPERTIES DEPENDS test_ics1)
add_test(NAME test_metadata2 COMMAND test_metadata result_v2a.ics)
set_tests_properties(test_metadata2 PROPERTIES DEPENDS test_ics2a)
add_test(NAME test_metadata3 COMMAND test_metadata result_v2b.ics)
set_tests_properties(test_metadata3 PROPERTIES DEPENDS test_ics2b)
add_test(NAME test_metadata4 COMMAND test_metadata result_v2z.ics)
set_tests_properties(test_metadata4 PROPERTIES DEPENDS test_gzip)
add_test(NAME test_history COMMAND test_history result_v1.ics)
set_tests_properties(test_history PROPERTIES DEPENDS test_ics1)

## libics 1.5.2

=== debian/changelog ===
libics (1.5.2-4ubuntu1) trusty; urgency=medium

  * Use autotools-dev instead of dh-autoreconf to also fix FTBFS on ppc64el by
    getting new libtool macros (still updates config.{sub,guess}).

 -- Logan Rosen <logan@ubuntu.com>  Wed, 15 Jan 2014 19:34:55 -0500

libics (1.5.2-4) unstable; urgency=low

  * Add symbols file
  * Bump to Std-Vers 3.9.4.
    - d/rules: move install target to install-arch

 -- Mathieu Malaterre <malat@debian.org>  Sun, 09 Jun 2013 17:01:57 +0200

libics (1.5.2-3) unstable; urgency=low

  * Use dh(9), get hardening for free
  * Add libics-doc package for documentation
  * Make multiarch

 -- Mathieu Malaterre <malat@debian.org>  Wed, 11 Apr 2012 18:57:00 +0200

libics (1.5.2-2) unstable; urgency=low

  * Pull svn rev 10 to fix big endian issues.

 -- Mathieu Malaterre <malat@debian.org>  Thu, 05 Apr 2012 09:05:59 +0200

libics (1.5.2-1) unstable; urgency=low

  * Initial Debian Upload (Closes: #666082)

 -- Mathieu Malaterre <malat@debian.org>  Wed, 28 Mar 2012 17:28:11 +0200

=== debian/control ===
Source: libics
Priority: optional
Section: libs
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Mathieu Malaterre <malat@debian.org>
Build-Depends: debhelper (>= 9), zlib1g-dev | libz-dev, dh-autoreconf
Standards-Version: 3.9.4
Homepage: http://libics.sf.net
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/libics/trunk/
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/libics/trunk/

Package: libics0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Image Cytometry Standard file reading and writing
 This is the reference library for ICS (Image Cytometry Standard), an open
 standard for writing images of any dimensionality and data type to file,
 together with associated information regarding the recording equipment or
 recorded subject.
 .
 This package contains the libraries needed to run ICS applications.

Package: libics-dev
Provides: libics0-dev
Section: libdevel
Architecture: any
Depends: libics0 (= ${binary:Version}), ${misc:Depends}
Description: Image Cytometry Standard file reading and writing
 This is the reference library for ICS (Image Cytometry Standard), an open
 standard for writing images of any dimensionality and data type to file,
 together with associated information regarding the recording equipment or
 recorded subject.
 .
 This package contains the libraries needed to build ICS applications.

Package: libics-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, doc-base
Description: Image Cytometry Standard file reading and writing
 This is the reference library for ICS (Image Cytometry Standard), an open
 standard for writing images of any dimensionality and data type to file,
 together with associated information regarding the recording equipment or
 recorded subject.
 .
 This package contains the libraries documentation for ICS

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --with autoreconf

pkg_run = libics0
pkg_dev = libics-dev

override_dh_install-arch:
	# Runtime Package
	dh_install -p$(pkg_run) usr/lib/$(DEB_HOST_MULTIARCH)/lib*.so.*
	# Development Package
	dh_install -p$(pkg_dev) usr/include
	dh_install -p$(pkg_dev) usr/lib/$(DEB_HOST_MULTIARCH)/lib*.a
	dh_install -p$(pkg_dev) usr/lib/$(DEB_HOST_MULTIARCH)/lib*.so

get-orig-source:
	uscan --verbose --force-download

=== debian/watch ===
version=3
http://sf.net/libics/libics-([\d\.]+)\.tar\.gz

## libics 1.6.2

=== debian/changelog ===
libics (1.6.2-2) unstable; urgency=medium

  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.1

 -- Andreas Tille <tille@debian.org>  Thu, 01 Nov 2018 15:18:22 +0100

libics (1.6.2-1) unstable; urgency=medium

  * New upstream version
    Closes: #882430

 -- Andreas Tille <tille@debian.org>  Sat, 02 Dec 2017 08:15:35 +0100

libics (1.6.1-1) unstable; urgency=medium

  [ Mathieu Malaterre ]
  * Remove self from Uploaders

  [ Andreas Tille ]
  * New upstream version
  * Moved packaging from SVN to Git
  * debhelper 10
  * Standards-Version: 4.1.1
  * Project moved to Github
  * hardening=+all
  * I'm to lazy to maintain symbols files for libs without rdepends
  * Use d-shlibs
  * DEP5
  * Distinct short descriptions for packages

 -- Andreas Tille <tille@debian.org>  Wed, 22 Nov 2017 12:55:06 +0100

libics (1.5.2-6) unstable; urgency=medium

  * Fix arch only builds
    Closes: #750617

 -- Andreas Tille <tille@debian.org>  Thu, 05 Jun 2014 09:32:22 +0200

libics (1.5.2-5) unstable; urgency=medium

  * use dh-autoreconf instead of autotools-dev to fix FTBFS on ppc64el
    (thanks for the patch to Logan Rosen <logan@ubuntu.com>)
    Closes: #735636
  * cme fix dpkg-control
  * debian/rules: remove privacy-breach-logo

 -- Andreas Tille <tille@debian.org>  Tue, 13 May 2014 15:25:22 +0200

=== debian/control ===
Source: libics
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 11~),
               d-shlibs,
               zlib1g-dev | libz-dev
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/med-team/libics
Vcs-Git: https://salsa.debian.org/med-team/libics.git
Homepage: https://svi-opensource.github.io/libics/

Package: libics0
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Image Cytometry Standard file reading and writing
 This is the reference library for ICS (Image Cytometry Standard), an open
 standard for writing images of any dimensionality and data type to file,
 together with associated information regarding the recording equipment or
 recorded subject.
 .
 This package contains the libraries needed to run ICS applications.

Package: libics-dev
Architecture: any
Section: libdevel
Depends: libics0 (= ${binary:Version}),
         ${misc:Depends}
Provides: libics0-dev
Description: Image Cytometry Standard file reading and writing (devel)
 This is the reference library for ICS (Image Cytometry Standard), an open
 standard for writing images of any dimensionality and data type to file,
 together with associated information regarding the recording equipment or
 recorded subject.
 .
 This package contains the libraries needed to build ICS applications.

Package: libics-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         doc-base
Description: Image Cytometry Standard file reading and writing (doc)
 This is the reference library for ICS (Image Cytometry Standard), an open
 standard for writing images of any dimensionality and data type to file,
 together with associated information regarding the recording equipment or
 recorded subject.
 .
 This package contains the libraries documentation for ICS

## libics 1.6.3

=== CMakeLists.txt ===
##############################################################################
#
# libics: Image Cytometry Standard file reading and writing.
#
# Copyright (C) 2000-2013, 2016 Cris Luengo and others
# Copyright 2015, 2016:
#   Scientific Volume Imaging Holding B.V.
#   Laapersveld 63, 1213 VB Hilversum, The Netherlands
#   https://www.svi.nl
#
#   CMakeLists.txt
#   Created by Paul Barber <paul.barber@oncology.ox.ac.uk>, Feb 2017
#   Heavily modified by Cris Luengo, July 2017
#
##############################################################################
cmake_minimum_required(VERSION 3.5)
if(POLICY CMP0068)
   cmake_policy(SET CMP0068 NEW)
endif()

project(libics VERSION 1.6.3)

# Note: the version number above is not yet used anywhere.
# TODO: rewrite the header file with this version number.
# The line below does not work: we need the installed header file to contain the version number also.
#add_definitions(-DICSLIB_VERSION="${libics_VERSION}")

# Compiler flags
set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED on)

if(CMAKE_C_COMPILER_ID MATCHES "Clang") # also matchs "AppleClang"
   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Wconversion -Wsign-conversion -pedantic")
elseif(CMAKE_C_COMPILER_ID STREQUAL "GNU")
   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Wconversion -Wsign-conversion -Wno-unused-parameter -pedantic")
elseif(CMAKE_C_COMPILER_ID STREQUAL "Intel")
   # TODO: compiler flags for Intel compiler
elseif(CMAKE_C_COMPILER_ID STREQUAL "MSVC")
   # TODO: compiler flags for MSVC compiler
endif()

# Debug or Release?
if(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE Release)
endif()

# ICS
configure_file(libics_conf.h.in ${CMAKE_CURRENT_SOURCE_DIR}/libics_conf.h COPYONLY)
set(SOURCES
      libics_binary.c
      libics_compress.c
      libics_data.c
      libics_gzip.c
      libics_history.c
      libics_preview.c
      libics_read.c
      libics_sensor.c
      libics_test.c
      libics_top.c
      libics_util.c
      libics_write.c
      libics_conf.h
      )

set(HEADERS
      libics.h
      libics_intern.h
      libics_ll.h
      libics_sensor.h
      libics_test.h
      )

add_library(libics ${SOURCES} ${HEADERS})

if(BUILD_SHARED_LIBS)
   target_compile_definitions(libics PRIVATE BUILD_ICSLIB) # When compiling DLL/SO
   target_compile_definitions(libics INTERFACE USE_ICSLIB_DLL) # When linking against DLL/SO
endif()

target_include_directories(libics PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)

if(UNIX)
   set_target_properties(libics PROPERTIES OUTPUT_NAME "ics")
   target_link_libraries(libics PUBLIC m)
endif(UNIX)

# Link against zlib
find_package(ZLIB)
if(ZLIB_FOUND)
   set(LIBICS_USE_ZLIB TRUE CACHE BOOL "Use Zlib in libics")
endif()
if(LIBICS_USE_ZLIB)
   target_link_libraries(libics PUBLIC ${ZLIB_LIBRARIES})
   target_include_directories(libics PRIVATE ${ZLIB_INCLUDE_DIRS})
   target_compile_definitions(libics PUBLIC -DICS_ZLIB)
endif()

# Reentrant string tokenization
include(CheckFunctionExists)
check_function_exists(strtok_r HAVE_STRTOK_R)
if(HAVE_STRTOK_R)
   target_compile_definitions(libics PRIVATE -DHAVE_STRTOK_R)
endif()

# Install
export(TARGETS libics FILE cmake/libicsTargets.cmake)

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
      cmake/libicsConfigVersion.cmake
      VERSION ${PACKAGE_VERSION}
      COMPATIBILITY AnyNewerVersion)

configure_package_config_file(
      cmake/libicsConfig.cmake.in
      cmake/libicsConfig.cmake
      INSTALL_DESTINATION cmake/)

install(TARGETS libics
      EXPORT libicsTargets
      ARCHIVE DESTINATION lib
      LIBRARY DESTINATION lib
      RUNTIME DESTINATION bin
      INCLUDES DESTINATION include)

install(FILES ${HEADERS} DESTINATION include)

install(FILES
      ${CMAKE_CURRENT_BINARY_DIR}/cmake/libicsConfig.cmake
      ${CMAKE_CURRENT_BINARY_DIR}/cmake/libicsConfigVersion.cmake
      DESTINATION cmake/)

install(EXPORT libicsTargets DESTINATION cmake)


# Unit tests
enable_testing()

add_executable(test_ics1 EXCLUDE_FROM_ALL test_ics1.c)
target_link_libraries(test_ics1 libics)
add_executable(test_ics2a EXCLUDE_FROM_ALL test_ics2a.c)
target_link_libraries(test_ics2a libics)
add_executable(test_ics2b EXCLUDE_FROM_ALL test_ics2b.c)
target_link_libraries(test_ics2b libics)
if(LIBICS_USE_ZLIB)
   add_executable(test_gzip EXCLUDE_FROM_ALL test_gzip.c)
   target_link_libraries(test_gzip libics)
endif()
add_executable(test_compress EXCLUDE_FROM_ALL test_compress.c)
target_link_libraries(test_compress libics)
add_executable(test_strides EXCLUDE_FROM_ALL test_strides.c)
target_link_libraries(test_strides libics)
add_executable(test_strides2 EXCLUDE_FROM_ALL test_strides2.c)
target_link_libraries(test_strides2 libics)
add_executable(test_strides3 EXCLUDE_FROM_ALL test_strides3.c)
target_link_libraries(test_strides3 libics)
add_executable(test_metadata EXCLUDE_FROM_ALL test_metadata.c)
target_link_libraries(test_metadata libics)
add_executable(test_history EXCLUDE_FROM_ALL test_history.c)
target_link_libraries(test_history libics)

set(TEST_PROGRAMS
      test_ics1
      test_ics2a
      test_ics2b
      test_compress
      test_strides
      test_strides2
      test_strides3
      test_metadata
      test_history
      )
if(LIBICS_USE_ZLIB)
   set(TEST_PROGRAMS ${TEST_PROGRAMS} test_gzip)
endif()
add_custom_target(all_tests DEPENDS ${TEST_PROGRAMS})

add_test(ctest_build_test_code "${CMAKE_COMMAND}" --build "${PROJECT_BINARY_DIR}" --target all_tests)
add_test(NAME test_ics1 COMMAND test_ics1 "${CMAKE_CURRENT_SOURCE_DIR}/test/testim.ics" result_v1.ics)
set_tests_properties(test_ics1 PROPERTIES DEPENDS ctest_build_test_code)
add_test(NAME test_ics2a COMMAND test_ics2a "${CMAKE_CURRENT_SOURCE_DIR}/test/testim.ics" result_v2a.ics)
set_tests_properties(test_ics2a PROPERTIES DEPENDS ctest_build_test_code)
add_test(NAME test_ics2b COMMAND test_ics2b "${CMAKE_CURRENT_SOURCE_DIR}/test/testim.ics" result_v2b.ics)
set_tests_properties(test_ics2b PROPERTIES DEPENDS ctest_build_test_code)
if(LIBICS_USE_ZLIB)
   add_test(NAME test_gzip COMMAND test_gzip "${CMAKE_CURRENT_SOURCE_DIR}/test/testim.ics" result_v2z.ics)
   set_tests_properties(test_gzip PROPERTIES DEPENDS ctest_build_test_code)
endif()
add_test(NAME test_compress COMMAND test_compress "${CMAKE_CURRENT_SOURCE_DIR}/test/testim.ics" "${CMAKE_CURRENT_SOURCE_DIR}/test/testim_c.ics")
set_tests_properties(test_compress PROPERTIES DEPENDS ctest_build_test_code)
add_test(NAME test_strides COMMAND test_strides "${CMAKE_CURRENT_SOURCE_DIR}/test/testim.ics" result_s.ics)
set_tests_properties(test_strides PROPERTIES DEPENDS ctest_build_test_code)
add_test(NAME test_strides2 COMMAND test_strides2 "${CMAKE_CURRENT_SOURCE_DIR}/test/testim.ics" result_s2.ics)
set_tests_properties(test_strides2 PROPERTIES DEPENDS ctest_build_test_code)
add_test(NAME test_strides3 COMMAND test_strides3 "${CMAKE_CURRENT_SOURCE_DIR}/test/testim.ics" result_s3.ics)
set_tests_properties(test_strides3 PROPERTIES DEPENDS ctest_build_test_code)
add_test(NAME test_metadata1 COMMAND test_metadata result_v1.ics)
set_tests_properties(test_metadata1 PROPERTIES DEPENDS test_ics1)
add_test(NAME test_metadata2 COMMAND test_metadata result_v2a.ics)
set_tests_properties(test_metadata2 PROPERTIES DEPENDS test_ics2a)
add_test(NAME test_metadata3 COMMAND test_metadata result_v2b.ics)
set_tests_properties(test_metadata3 PROPERTIES DEPENDS test_ics2b)
if(LIBICS_USE_ZLIB)
   add_test(NAME test_metadata4 COMMAND test_metadata result_v2z.ics)
   set_tests_properties(test_metadata4 PROPERTIES DEPENDS test_gzip)
endif()
add_test(NAME test_history COMMAND test_history result_v1.ics)
set_tests_properties(test_history PROPERTIES DEPENDS test_ics1)


# Include the C++ interface?
set(LIBICS_INCLUDE_CPP TRUE CACHE BOOL "Include the C++ interface")
if(LIBICS_INCLUDE_CPP)
   include(support/cpp_interface/CMakeLists.txt)
endif()

=== debian/changelog ===
libics (1.6.3-1) unstable; urgency=medium

  * New upstream version
  * debhelper-compat 12
  * Standards-Version: 4.4.0
  * Ignore failing test

 -- Andreas Tille <tille@debian.org>  Thu, 01 Aug 2019 14:07:35 +0200

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,10 @@
 Uploaders: Andreas Tille <tille@debian.org>
 Section: libs
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 12),
                d-shlibs,
                zlib1g-dev | libz-dev
-Standards-Version: 4.2.1
+Standards-Version: 4.4.0
 Vcs-Browser: https://salsa.debian.org/med-team/libics
 Vcs-Git: https://salsa.debian.org/med-team/libics.git
 Homepage: https://svi-opensource.github.io/libics/

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_install-arch:
	dh_install -a
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
                    --movedev debian/tmp/usr/include usr \
                    debian/tmp/usr/lib/*/*.so

## libics 1.6.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,7 +18,7 @@
    cmake_policy(SET CMP0068 NEW)
 endif()
 
-project(libics VERSION 1.6.3)
+project(libics VERSION 1.6.4)
 
 # Note: the version number above is not yet used anywhere.
 # TODO: rewrite the header file with this version number.

=== debian/changelog ===
libics (1.6.4-1) unstable; urgency=medium

  [ Michael R. Crusoe ]
  * Team upload.
  * New upstream version
  * Standards-Version: 4.5.0 (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Add symbols file
  * Run the tests serially
    Closes: #953191

  [ Andreas Tille ]
  * Add salsa-ci file (routine-update)

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sat, 07 Mar 2020 08:10:12 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends: debhelper-compat (= 12),
                d-shlibs,
                zlib1g-dev | libz-dev
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/med-team/libics
 Vcs-Git: https://salsa.debian.org/med-team/libics.git
 Homepage: https://svi-opensource.github.io/libics/

=== debian/rules ===
--- 
+++ 
@@ -15,3 +15,8 @@
 		    --exclude-la \
                     --movedev debian/tmp/usr/include usr \
                     debian/tmp/usr/lib/*/*.so
+
+override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+	make -j1 check VERBOSE=1
+endif

=== debian/watch ===
version=4

https://github.com/svi-opensource/libics/releases .*/archive/@ANY_VERSION@@ARCHIVE_EXT@

## libics 1.6.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,7 +18,7 @@
    cmake_policy(SET CMP0068 NEW)
 endif()
 
-project(libics VERSION 1.6.4)
+project(libics VERSION 1.6.5)
 
 # Note: the version number above is not yet used anywhere.
 # TODO: rewrite the header file with this version number.

=== support/cpp_interface/CMakeLists.txt ===
##############################################################################
#
# libics: Image Cytometry Standard file reading and writing.
#
# C++ interface
# Copyright 2018 Cris Luengo
#
##############################################################################

# Compiler flags
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED on)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)

if(CMAKE_CXX_COMPILER_ID MATCHES "Clang") # also matchs "AppleClang"
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wconversion -Wsign-conversion -pedantic")
elseif(CMAKE_C_COMPILER_ID STREQUAL "GNU")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wconversion -Wsign-conversion -pedantic")
elseif(CMAKE_C_COMPILER_ID STREQUAL "Intel")
   # TODO: compiler flags for Intel compiler
elseif(CMAKE_C_COMPILER_ID STREQUAL "MSVC")
   # TODO: compiler flags for MSVC compiler
endif()

set(SOURCES ${CMAKE_CURRENT_LIST_DIR}/libics.cpp)
set(HEADERS ${CMAKE_CURRENT_LIST_DIR}/libics.hpp)

add_library(libics_cpp ${SOURCES} ${HEADERS})
target_link_libraries(libics_cpp PRIVATE libics)

if(BUILD_SHARED_LIBS)
   target_compile_definitions(libics_cpp PRIVATE BUILD_ICSCPP) # When compiling DLL/SO
   target_compile_definitions(libics_cpp INTERFACE USE_ICSCPP_DLL) # When linking against DLL/SO
endif()

target_include_directories(libics_cpp PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)

if(UNIX)
   set_target_properties(libics_cpp PROPERTIES OUTPUT_NAME "ics_cpp")
endif(UNIX)

# Install
export(TARGETS libics_cpp FILE cmake/libics_cppTargets.cmake)

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
      cmake/libics_cppConfigVersion.cmake
      VERSION ${PACKAGE_VERSION}
      COMPATIBILITY AnyNewerVersion)

configure_package_config_file(
      ${CMAKE_CURRENT_SOURCE_DIR}/cmake/libicsConfig.cmake.in
      cmake/libics_cppConfig.cmake
      INSTALL_DESTINATION cmake/)

install(TARGETS libics_cpp
      EXPORT libics_cppTargets
      ARCHIVE DESTINATION lib
      LIBRARY DESTINATION lib
      RUNTIME DESTINATION bin
      INCLUDES DESTINATION include)

install(FILES ${HEADERS} DESTINATION include)

install(FILES
      ${CMAKE_CURRENT_BINARY_DIR}/cmake/libics_cppConfig.cmake
      ${CMAKE_CURRENT_BINARY_DIR}/cmake/libics_cppConfigVersion.cmake
      DESTINATION cmake/)

install(EXPORT libics_cppTargets DESTINATION cmake)


# Unit tests
add_executable(test_ics2a_cpp EXCLUDE_FROM_ALL ${CMAKE_CURRENT_LIST_DIR}/test_ics2a.cpp)
target_link_libraries(test_ics2a_cpp libics_cpp)
add_executable(test_ics2b_cpp EXCLUDE_FROM_ALL ${CMAKE_CURRENT_LIST_DIR}/test_ics2b.cpp)
target_link_libraries(test_ics2b_cpp libics_cpp)
add_executable(test_metadata_cpp EXCLUDE_FROM_ALL ${CMAKE_CURRENT_LIST_DIR}/test_metadata.cpp)
target_link_libraries(test_metadata_cpp libics_cpp)
add_executable(test_history_cpp EXCLUDE_FROM_ALL ${CMAKE_CURRENT_LIST_DIR}/test_history.cpp)
target_link_libraries(test_history_cpp libics_cpp)

set(TEST_PROGRAMS ${TEST_PROGRAMS} test_ics2a_cpp test_ics2b_cpp test_metadata_cpp test_history_cpp)
add_dependencies(all_tests ${TEST_PROGRAMS})

add_test(NAME test_ics2a_cpp COMMAND test_ics2a_cpp "${CMAKE_CURRENT_SOURCE_DIR}/test/testim.ics" result_v2a_cpp.ics)
set_tests_properties(test_ics2a_cpp PROPERTIES DEPENDS ctest_build_test_code)
add_test(NAME test_ics2b_cpp COMMAND test_ics2b_cpp "${CMAKE_CURRENT_SOURCE_DIR}/test/testim.ics" result_v2b_cpp.ics)
set_tests_properties(test_ics2b_cpp PROPERTIES DEPENDS ctest_build_test_code)
add_test(NAME test_metadata1_cpp COMMAND test_metadata_cpp result_v1.ics)
set_tests_properties(test_metadata1_cpp PROPERTIES DEPENDS test_ics1)
add_test(NAME test_metadata2_cpp COMMAND test_metadata_cpp result_v2a.ics)
set_tests_properties(test_metadata2_cpp PROPERTIES DEPENDS test_ics2a)
add_test(NAME test_metadata3_cpp COMMAND test_metadata_cpp result_v2b.ics)
set_tests_properties(test_metadata3_cpp PROPERTIES DEPENDS test_ics2b)
if(LIBICS_USE_ZLIB)
   add_test(NAME test_metadata4_cpp COMMAND test_metadata_cpp result_v2z.ics)
   set_tests_properties(test_metadata4_cpp PROPERTIES DEPENDS test_gzip)
endif()
add_test(NAME test_history_cpp COMMAND test_history_cpp result_v1.ics)
set_tests_properties(test_history_cpp PROPERTIES DEPENDS test_ics1)

=== debian/changelog ===
libics (1.6.5-2) unstable; urgency=medium

  * d/watch: Add filenamemangle
  * Do not build anything when just creating doc package
    Closes: #996334

 -- Andreas Tille <tille@debian.org>  Wed, 13 Oct 2021 15:44:31 +0200

libics (1.6.5-1) unstable; urgency=medium

  * Fix watchfile to detect new versions on github
  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Remove Section on libics0 that duplicates source.
  * Apply multi-arch hints.
    + libics-dev, libics0: Add Multi-Arch: same.
  * Prevent lintian-brush from removing duplicate section entry which is
    needed by d-shlibs by using Section: science for source package
  * Deal with unneded *.la file

 -- Andreas Tille <tille@debian.org>  Wed, 13 Oct 2021 09:53:43 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,16 @@
 Source: libics
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Andreas Tille <tille@debian.org>
-Section: libs
+Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                d-shlibs,
                zlib1g-dev | libz-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/libics
 Vcs-Git: https://salsa.debian.org/med-team/libics.git
 Homepage: https://svi-opensource.github.io/libics/
+Rules-Requires-Root: no
 
 Package: libics0
 Architecture: any
@@ -17,6 +18,7 @@
 Depends: ${misc:Depends},
          ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
+Multi-Arch: same
 Description: Image Cytometry Standard file reading and writing
  This is the reference library for ICS (Image Cytometry Standard), an open
  standard for writing images of any dimensionality and data type to file,
@@ -31,6 +33,7 @@
 Depends: libics0 (= ${binary:Version}),
          ${misc:Depends}
 Provides: libics0-dev
+Multi-Arch: same
 Description: Image Cytometry Standard file reading and writing (devel)
  This is the reference library for ICS (Image Cytometry Standard), an open
  standard for writing images of any dimensionality and data type to file,

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/svi-opensource/libics/releases .*/@ANY_VERSION@@ARCHIVE_EXT@

## libics 1.6.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,7 +18,7 @@
    cmake_policy(SET CMP0068 NEW)
 endif()
 
-project(libics VERSION 1.6.5)
+project(libics VERSION 1.6.6)
 
 # Note: the version number above is not yet used anywhere.
 # TODO: rewrite the header file with this version number.

=== debian/changelog ===
libics (1.6.6-1build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 11:45:21 +0200

libics (1.6.6-1) unstable; urgency=medium

  * Fix watch file
  * New upstream version
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Tue, 29 Nov 2022 11:27:06 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: libics
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                d-shlibs,
                zlib1g-dev | libz-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/med-team/libics
 Vcs-Git: https://salsa.debian.org/med-team/libics.git
 Homepage: https://svi-opensource.github.io/libics/

## libics 1.6.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 # Copyright (C) 2000-2013, 2016 Cris Luengo and others
 # Copyright 2015, 2016:
 #   Scientific Volume Imaging Holding B.V.
-#   Laapersveld 63, 1213 VB Hilversum, The Netherlands
+#   Hilversum, The Netherlands.
 #   https://www.svi.nl
 #
 #   CMakeLists.txt
@@ -18,7 +18,7 @@
    cmake_policy(SET CMP0068 NEW)
 endif()
 
-project(libics VERSION 1.6.6)
+project(libics VERSION 1.6.8)
 
 # Note: the version number above is not yet used anywhere.
 # TODO: rewrite the header file with this version number.
@@ -213,3 +213,4 @@
 if(LIBICS_INCLUDE_CPP)
    include(support/cpp_interface/CMakeLists.txt)
 endif()
+

=== debian/changelog ===
libics (1.6.8-1) unstable; urgency=medium

  * New upstream version 1.6.8
  * d/copyright: update copyright year and upstream change.
  * d/control: add myself to uploaders.
  * d/control: declare compliance to standards version 4.7.0.
  * d/libics0.symbols: declare Build-Depends-Package field.
  * ignore_failing_test.patch: delete: issue resolved upstream.

 -- Étienne Mollier <emollier@debian.org>  Sun, 03 Nov 2024 17:51:03 +0100

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,13 @@
 Source: libics
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Andreas Tille <tille@debian.org>
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Uploaders: Andreas Tille <tille@debian.org>,
+           Étienne Mollier <emollier@debian.org>
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                d-shlibs,
                zlib1g-dev | libz-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/med-team/libics
 Vcs-Git: https://salsa.debian.org/med-team/libics.git
 Homepage: https://svi-opensource.github.io/libics/

=== debian/rules ===
--- 
+++ 
@@ -7,6 +7,12 @@
 %:
 	dh $@
 
+override_dh_auto_configure-indep:
+override_dh_auto_build-indep:
+override_dh_auto_test-indep:
+override_dh_auto_install-indep:
+	echo "Do not anything when just creating doc package"
+
 override_dh_install-arch:
 	dh_install -a
 	d-shlibmove --commit \
@@ -15,8 +21,9 @@
 		    --exclude-la \
                     --movedev debian/tmp/usr/include usr \
                     debian/tmp/usr/lib/*/*.so
+	find debian -name "lib*.la" -delete
 
-override_dh_auto_test:
+override_dh_auto_test-arch:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	make -j1 check VERBOSE=1
 endif

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/svi-opensource/libics/tags .*/@ANY_VERSION@@ARCHIVE_EXT@

## libics 1.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,7 +18,7 @@
    cmake_policy(SET CMP0068 NEW)
 endif()
 
-project(libics VERSION 1.6.8)
+project(libics VERSION 1.7.0)
 
 # Note: the version number above is not yet used anywhere.
 # TODO: rewrite the header file with this version number.

=== debian/changelog ===
libics (1.7.0-1) unstable; urgency=medium

  * New upstream version 1.7.0
  * d/copyright: bump upstream copyright year.
  * d/control: declare compliance to standards version 4.7.2.
  * d/control: drop redundant Rules-Requires-Root: no.
  * d/watch: convert to v5 Github template.
  * d/rules: trim unused variable.
  * d/copyright: drop the old FSF mail address.
  * d/rules: stabilize running tests.
    Checks are invoked by enforcing make execution order.  Anything more
    appropriate is also going to be much more intrusive upstream.
    (Closes: #1105503)

 -- Étienne Mollier <emollier@debian.org>  Sat, 15 Nov 2025 23:53:58 +0100

=== debian/control ===
--- 
+++ 
@@ -7,11 +7,10 @@
 Build-Depends: debhelper-compat (= 13),
                d-shlibs,
                zlib1g-dev | libz-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/libics
 Vcs-Git: https://salsa.debian.org/med-team/libics.git
 Homepage: https://svi-opensource.github.io/libics/
-Rules-Requires-Root: no
 
 Package: libics0
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,4 @@
 #!/usr/bin/make -f
-
-DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 
@@ -25,5 +23,6 @@
 
 override_dh_auto_test-arch:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	make -j1 check VERBOSE=1
+	# Test items are expected to be run in their declared order.
+	$(MAKE) --shuffle=none -j1 check VERBOSE=1
 endif

=== debian/watch ===
Version: 5

Template: Github
Owner: svi-opensource
Project: libics
